#include <mathlib/simd/config.h>

#if MATHLIB_GCC_SSE

#include <mathlib/matrix.tpp>

#include <xmmintrin.h>

namespace mathlib {

void simd_assign_handler<unop_copy>::go(bm44 &dest,
	matrix_binop<binop_mmul<4>, bm44, bm44> src) {

	v4sf v, f1, f2, f3, f4;
	v4sf c1, c2, c3, c4;
	v4sf ac1, ac2, ac3, ac4;
	v4sf s1, s2;

	ac1 = ssev(src.a)[0];
	ac2 = ssev(src.a)[1];
	ac3 = ssev(src.a)[2];
	ac4 = ssev(src.a)[3];

	v = ssev(src.b)[0];
	f1 = __builtin_ia32_shufps(v, v, 0x00);
	f2 = __builtin_ia32_shufps(v, v, 0x55);
	f3 = __builtin_ia32_shufps(v, v, 0xaa);
	f4 = __builtin_ia32_shufps(v, v, 0xff);
	c1 = __builtin_ia32_mulps(f1, ac1);
	c2 = __builtin_ia32_mulps(f2, ac2);
	c3 = __builtin_ia32_mulps(f3, ac3);
	c4 = __builtin_ia32_mulps(f4, ac4);
	s1 = __builtin_ia32_addps(c1, c2);
	s2 = __builtin_ia32_addps(c3, c4);
	ssev(dest)[0] = __builtin_ia32_addps(s1, s2);

	v = ssev(src.b)[1];
	f1 = __builtin_ia32_shufps(v, v, 0x00);
	f2 = __builtin_ia32_shufps(v, v, 0x55);
	f3 = __builtin_ia32_shufps(v, v, 0xaa);
	f4 = __builtin_ia32_shufps(v, v, 0xff);
	c1 = __builtin_ia32_mulps(f1, ac1);
	c2 = __builtin_ia32_mulps(f2, ac2);
	c3 = __builtin_ia32_mulps(f3, ac3);
	c4 = __builtin_ia32_mulps(f4, ac4);
	s1 = __builtin_ia32_addps(c1, c2);
	s2 = __builtin_ia32_addps(c3, c4);
	ssev(dest)[1] = __builtin_ia32_addps(s1, s2);

	v = ssev(src.b)[2];
	f1 = __builtin_ia32_shufps(v, v, 0x00);
	f2 = __builtin_ia32_shufps(v, v, 0x55);
	f3 = __builtin_ia32_shufps(v, v, 0xaa);
	f4 = __builtin_ia32_shufps(v, v, 0xff);
	c1 = __builtin_ia32_mulps(f1, ac1);
	c2 = __builtin_ia32_mulps(f2, ac2);
	c3 = __builtin_ia32_mulps(f3, ac3);
	c4 = __builtin_ia32_mulps(f4, ac4);
	s1 = __builtin_ia32_addps(c1, c2);
	s2 = __builtin_ia32_addps(c3, c4);
	ssev(dest)[2] = __builtin_ia32_addps(s1, s2);

	v = ssev(src.b)[3];
	f1 = __builtin_ia32_shufps(v, v, 0x00);
	f2 = __builtin_ia32_shufps(v, v, 0x55);
	f3 = __builtin_ia32_shufps(v, v, 0xaa);
	f4 = __builtin_ia32_shufps(v, v, 0xff);
	c1 = __builtin_ia32_mulps(f1, ac1);
	c2 = __builtin_ia32_mulps(f2, ac2);
	c3 = __builtin_ia32_mulps(f3, ac3);
	c4 = __builtin_ia32_mulps(f4, ac4);
	s1 = __builtin_ia32_addps(c1, c2);
	s2 = __builtin_ia32_addps(c3, c4);
	ssev(dest)[3] = __builtin_ia32_addps(s1, s2);
}

} // namespace mathlib

#endif // MATHLIB_GCC_SSE
